/*
 * mysql_auth_md5 - additional encryption for mysql_auth
 *
 * mysql_auth_md5.c
 * (C) 2008 Andras Miko
 * Released under GPL, see COPYING-2.0 for details.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include "define.h"
#include "md5.h"

int f_md5 (char *buffer, char *str) {
	char hex_output[16 * 2 + 1];
	int di;
	int lstr = strlen (str);

	md5_state_t state;
	md5_byte_t digest[16];

	md5_init (&state);
	md5_append (&state, (const md5_byte_t *)str, lstr);
	md5_finish (&state, digest);

	for (di = 0; di < 16; ++di) sprintf (hex_output + di * 2, "%02x", digest[di]);

	memcpy (buffer, hex_output, 32);
	buffer[32] = '\0';
	return 0;
}
